unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    Memo2: TMemo;
    Button2: TButton;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;
type TarrayOfArrayOfExtended = array of array of extended;


var
  Form1: TForm1;

implementation

uses mathmohr, polynom;
{$R *.DFM}

function IsInteger(const x: extended; eps: extended): boolean;
begin
  result := frac(abs(x) + eps) < eps*2;
end;

FUNCTION ggtInt(a,b:longint):longint;
  begin if b=0 then result:=a
        else result:=ggtInt(b,a mod b);
  end;

FUNCTION ggtReal(a,b:Extended):Extended;
  begin if (abs(a) < maxlongint) and (abs(b) < maxlongint) then
           result:=ggTInt(round(a),round(b))
        else Begin
          if abs(b) < 0.5 then result:=a
          else result:=ggtReal(b,a-b*int(a/b));
        end;
end;

FUNCTION kgVReal(a, b: extended): extended;
begin result := a * b / ggTReal(a, b) end;

function fest(s:string): string;
  const L=12;
begin
  result := s;
  while length(result) < L do result := result + ' ';
end;

procedure ArrayInMemo(n: integer; aa: TarrayOfArrayOfExtended; m:Tmemo);
  var i, j: integer;   //aa n zeilen und n + 1 Spalten
      s: string;
begin
  m.Lines.Clear;
  for i := 0 to n-1 do Begin
    s := '';
    for j := 0 to n do
      s := s + fest(floatToStr(aa[i,j]));
    m.Lines.Add(s);
  End;
end;

procedure LSG(n: integer; var aa: TarrayOfArrayOfExtended; var xx: array of extended);  //Arrray aa[0..n,0..n+1]
var i0, j0,j0max: integer; //n Unbekannte bzw. Gleichungen
  p, q: array of integer; //permutation q=inv_p
  procedure invers; //erzeugt q = inverse Permutation von p
  var u, v: integer;
  begin
    for u := 0 to n - 1 do
      for v := 0 to n - 1 do
        if p[u] = v then q[v] := u;
  end;
  procedure tausche_sp(i, j: integer); // Spalten werden ausgetauscht
  var u, k: integer;
    x: extended;
  begin
    for u := 0 to n - 1 do Begin
      x := aa[u, i];
      aa[u, i] := aa[u, j];
      aa[u, j] := x; //=altes aa[u,i]
    End;
    k := p[i];
    p[i] := p[j];
    p[j] := k; //altes p[i]
    invers;
  end;

  procedure macheZeileGanzzahlig(zeile: integer); //bis auf rechte Seite  aa[z,n+1]
  var k : integer;
    d, zae, nen: extended; //wird das kgV des Nenners
  begin
    try
      d := 1;
      for k := 0 to n - 1 do Begin
        if not ErmittleBruch(abs(aa[zeile, k]), zae, nen,g_eps) then exit;
        d := kgVReal(nen, d);
      End;
      for k := 0 to n do aa[zeile, k] := d * aa[zeile, k];
      //Jetzt noch krzen
      if not isInteger(aa[zeile, 1], g_eps) then exit;
      d := round(aa[zeile, 1]);
      for k := 0 to n - 1 do Begin
        if not isInteger(aa[zeile, k], g_eps) then exit;
        if d = 0 then d := round(aa[zeile, k]); //falls aa[zeile,1..]=0
        if abs(aa[zeile, k]) > 0 then
          d := ggTReal(round(aa[zeile, k]), d);
      End;
      if d <> 0 then for k := 0 to n do aa[zeile, k] := aa[zeile, k] / d;
    except {dann halt nicht} end;
    if aa[zeile, zeile] < 0 then for k := 0 to n do aa[zeile, k] := -aa[zeile, k];
  end;

  procedure VereinfacheRest(i: integer);
  var zeile, spalte: integer;
    d: extended;
  begin
    for zeile := 0 to n - 1 do if zeile <> i then Begin
        d := aa[zeile, i] / aa[i, i];
        if d <> 0 then Begin
          for spalte := 0 to n do if spalte <> i then
              aa[zeile, spalte] := aa[zeile, spalte] - d * aa[i, spalte] else
              aa[zeile, i] := 0; //=aa[zeile,i]-aa[zeile,i]/aa[i,i]*aa[i,i]
          macheZeileGanzzahlig(zeile);
        End;
      End;
  end;

begin //Hauptprogramm
  setlength(p,n+1);
  setlength(q,n);
  for j0 := 0 to n - 1 do Begin
    p[j0] := j0;
    q[j0] := j0;
  End;
  for i0 := 0 to n - 1 do Begin
    j0max := i0;
    for j0 := i0 + 1 to n - 1 do if abs(aa[i0, j0]) > abs(aa[i0, j0max]) then j0max := j0;
    if aa[i0,j0max] = 0 then Begin
      showmessage('Keine eindeutige Lsng!');
      exit;
    End;
    VereinfacheRest(i0);
  end;
  for i0 := 0 to n - 1 do xx[p[i0]] := aa[i0, n] ;
end;


function hoch(x: real; n:integer): real; //n=0, 1, 2, ...
begin
  if n = 0 then result := 1 else
    result := x*hoch(x,n - 1)
end;


function s(n,k:integer): extended; //=1^k + 2^k + 3^k + ... + n^k
  var i:integer;
begin
  result := 0;
  for i := 1 to n do result := result + hoch(i,k);
end;

function mitBruchgerechnet(x: extended): extended;
begin
  result := TermToReal(reellZuBruch(x,g_eps));
end;

procedure probe(k: integer; a: array of extended);
  var n,j: integer;
      erg1,erg3: string;
      su: extended;
begin
  with form1.memo1.lines do Begin
    add('Probe');
    for n := 0 to k + 5 do BEgin
      erg1 := floatToStr(S(n,k)); //s := 1^k + 2^k + ... + n^k
      su := 0;
      for j := 0 to k + 1 do
        su := su + mitBruchgerechnet(a[j])*hoch(n,j); //s := a0 + a1*n + ... + a(k+1)*n^(k+1)
        erg3 := floatToStr(su);
      add('S(' + intToStr(n) + '|' + IntToStr(k)+')= ' + erg1 // + ' ?=? ' + erg2
          + ' ?=? ' + erg3);
    ENd;
  End;
end;

function evtlmitklammer(const s:string):string;
begin
  result := s;
  if not form1.checkbox1.checked then exit;
  if (pos('+',s) > 0) or (pos('-',s) > 0) then result := '(' + s + ')';
end;


procedure TForm1.Button1Click(Sender: TObject);
  var k, i, j: integer;
      koeff: TarrayOfArrayOfExtended;
      a: TarrayOfExtended;
      Linearfaktoren: string;
begin
  k := StrToInt(edit1.text);//gesucht Formel fr S(n,k)
  setlength(a, k+2); //s(n,k) = a0 + a1*n  ... a(k+1)*n^(k+1) (a0=0)
  setlength(koeff, length(a) + 1,length(a) + 2);
  for i := 0 to length(a) do Begin
    for j := 0 to length(a) - 1 do koeff[i,j] := hoch(i,j);
    koeff[i,length(a)] := s(i,length(a)-2);//rechte Seite
  End;
  ArrayInMemo(length(a),Koeff,memo1);
  LSG(length(a),koeff,a);
  if checkbox1.checked then ZerlegeInLinearfaktoren(a,Linearfaktoren,'n');
  memo1.Lines.Add(evtlmitklammer(PolynomToStr(a,'n')) + Linearfaktoren);
  if not checkbox1.checked then probe(k,a);
end;

function copyab(const s:string; const i:integer):string;  //Rest von s ab i. em Zeichen
  begin result:=copy(s,i,length(s)-i+1) end;

function nachminusleerzeichen(s:string):string;
begin
  s := trim(s);
  if (s>'') and (s[1]='-') then result := '- ' + copyab(s,2) else
    result := s;
end;



procedure TForm1.Button2Click(Sender: TObject);
  var k, i, j: integer;
      koeff,koeff0: TarrayOfArrayOfExtended;
      a: TarrayOfExtended;
      term, Linearfaktoren :string;
begin
memo1.Lines.Clear;
for k := 0 to 12 do begin {*}
  setlength(a, k+2); //s(n,k) = a0 + a1*n  ... a(k+1)*n^(k+1) (a0=0)
  setlength(koeff, length(a) + 1,length(a) + 2);
  setlength(koeff0, length(a) + 1,length(a) + 2);
  for i := 0 to length(a) do Begin
    for j := 0 to length(a) - 1 do koeff[i,j] := hoch(i,j);
    koeff[i,length(a)] := s(i,length(a)-2)//rechte Seite
  End;
  LSG(length(a),koeff,a);
  if checkbox1.checked then ZerlegeInLinearfaktoren(a,Linearfaktoren,'n');
  term := intTostr(k);
  term := '1^' + term + ' + 2^' +  term + ' + 3^' + term + ' ... ' + ' + n^' + term;
  memo1.Lines.Add(term + ' = ' + evtlmitklammer(PolynomToStr(a,'n')) + Linearfaktoren);
end{*} end;


end.
