unit polynom;

interface

type TarrayOfExtended = array of extended;

function Polynomgrad(const a: TarrayOfExtended): integer;
function PolynomToStr(const a: TarrayofExtended; const x:char):string; //n='n' oder 'x'
procedure ZerlegeInLinearfaktoren(var a:TarrayOfExtended; var Linearfaktoren:string; const c:char);
function polynomwert(const a: TarrayOfExtended;const x:extended): extended;

implementation

uses sysutils,  dialogs, mathMohr;

function Polynomgrad(const a: TarrayOfExtended): integer;
  var k:integer;
begin
  result := 0;
  for k := 0 to length(a) - 1 do if abs(a[k]) > g_eps then result := k;
end;

function polynomwert(const a: TarrayOfExtended; const x:extended): extended;
  var k:integer;
  {result = a[n]
  result := x*result + a[n-1] =x*a[n] + a[n-1]
  result := x*result + a[n-2] = x^2*a[n] + x*a[n-1] + a[n-2]
  ...
  result := x*result + a[0] = x^n*a[n] +x^(n-1)*a[n-1] + ... + a[0]}
begin
  result :=0;
  for k := Polynomgrad(a) downto 0 do result := x*result + a[k];
end;

function PolynomToStr(const a: TarrayofExtended; const x:char):string; //n='n' oder 'x'
  var i: integer;
      ai, vz: string;
begin
  result := '';
  for i := Polynomgrad(a) downto 0 do Begin
    ai := ReellZuBruch(a[i],g_eps);
    if ai='0' then continue;
    if ai[1] = '-' then Begin
      vz := '-';
      ai := copyab(ai,2);
    End  else vz :='+';
    if result > '' then result := result + ' ' + vz + ' ';
    if (ai <> '1') or (i=0) then result := result + ai;
    if (i <> 0) and (ai<>'1') and (ai<>'-1') then result := result + '*';
    if i >= 1 then result := result + x;
    if i > 1 then result := result + '^' + intToStr(i);
  End;
  if result = '' then result := '0';
end;

procedure setzePolynombGleichPolynoma(var b: TarrayofExtended; const a: TarrayofExtended);
  var k:integer;
begin
  setlength(b,length(a));
  for k := 0 to length(a) - 1 do b[k] := a[k];
end;

function dividiereDurchLinearfaktor(var a: TarrayOfExtended; x0:extended; c:char): string;
  //(a[n]x^n + ... + a[2]x^2 + a[1]*x+a[0]) : (x- x0) = a
  var k: integer;
      VZ: char;
      b: TarrayofExtended;
begin
  //'(x-x0)'
  if x0 < 0 then VZ := '+' else VZ := '-';
  if abs(x0) < g_eps then result := '*' + c else
    result := '*(n' + VZ + ReellZuBruch(abs(x0),g_eps) + ')';
  //showmessage('Polynom=' + PolynomToStr(a,c));
  setzePolynombGleichPolynoma(b,a);
  a[polynomgrad(a)] := 0;
  for k := polynomgrad(b) - 1 downto 0 do Begin
    a[k] := b[k+1];
    b[k] := b[k] + x0*b[k+1];
    //showmessage(intToStr(k) + '->' + floatToStr(a[k]));
  End;
   //showmessage('Restpolynom=' + PolynomToStr(a,c));
end;

procedure  ZerlegeInLinearfaktoren(var a:TarrayOfExtended;var  Linearfaktoren:string; const c:char);
   var x0: integer;
begin
  Linearfaktoren := '';
  for x0 := -1200 to 1200 do while abs(Polynomwert(a,x0/720)) < 1E-10 do Begin
    Linearfaktoren := Linearfaktoren + dividiereDurchLinearfaktor(a,x0/720,c);
  End;
end;

end.

